#include <Keypad.h>

  const int LED_RED = 2;                              // красный светодиод
  const int LED_GREEN = 4;                            // зеленый светодиод
  const int RELAY = 14;                               // реле
  const int BUZZER = 3;                               // пищалка

  const int NUM_KEYS = 4;                             // знаков в коде
  char myarraw[NUM_KEYS] = { 'A', 'B', 'C', 'D'};     // Секретное слово
  char button_pressed[NUM_KEYS];                      //массив для хранения нажатий

  int k=0;                                            // счетчик нажатий
  int s=0;                                            // счетчик совпадений нажатых кнопок с верными
  
const byte ROWS = 4;                                  //4 строчки
const byte COLS = 4;                                  //4 ряда

char hexaKeys[ROWS][COLS] = {
  {'1','2','3','A'},
  {'4','5','6','B'},
  {'7','8','9','C'},
  {'*','0','#','D'}
};

     
byte rowPins[ROWS] =  {5,12,11,10};                   //горизонтальных   
byte colPins[COLS] =  {9,8,7,6};                      //вертикальных 

Keypad customKeypad = Keypad( makeKeymap(hexaKeys), rowPins, colPins, ROWS, COLS); 

void setup(){
  Serial.begin(9600);
  pinMode(LED_RED, OUTPUT);                           // красный светодиод
  pinMode(LED_GREEN, OUTPUT);                         // зеленый светодиод
  pinMode(RELAY, OUTPUT);                             // реле управления замком
  pinMode(BUZZER, OUTPUT);                            // пищалка
  digitalWrite(RELAY, HIGH);                          // Отключаем реле
  
  Serial.println("Введите код");
}


  void correctPIN() // Код введён правильно
    {
     Serial.println("Доступ разрешён");
     digitalWrite(RELAY, LOW);                        // Включаем реле
     digitalWrite (LED_GREEN, HIGH);                  // Зажигаем зелёный светодиод
     
     delay(5000);                                     // Ждём 5 секунд
     digitalWrite(RELAY, HIGH);                       // Отключаем реле
     digitalWrite (LED_GREEN, LOW);                   // Гасим зелёный светодиод
     Serial.println("*******************");
     Serial.println("*** Введите код ***");
     Serial.println("*******************");
  
    }
  void incorrectPIN() // Код введён НЕ правильно
    {
    digitalWrite (LED_RED, HIGH);                    // Зажигаем красный светодиод      

    tone(BUZZER, 800, 200);                          // звуковой сигнал    
      delay(200);                                    // задержка    
      noTone(BUZZER);                                // отключение звукового сигнала
      tone(BUZZER, 500, 200);
      delay(200);
      noTone(BUZZER);
        tone(BUZZER, 600, 200);
      delay(200);
      noTone(BUZZER);
          tone(BUZZER, 700, 200);
      delay(200);
      noTone(BUZZER);
          tone(BUZZER, 800, 200);
      delay(200);
      noTone(BUZZER);
     delay(1000);
    digitalWrite (LED_RED, LOW);                      // Гасим красный светодиод
    Serial.println("Попробуйте снова");
    }


  
void loop(){

  char customKey = customKeypad.getKey();             // Присваиваем нажатие кнопки
 if ( customKey != NO_KEY ) {                         // если окнопка нажата  
    
    button_pressed [k] = customKey;                   //сохраняем в массив
  
    k++;                                              // увеличиваем кол-во нажатий
      switch(customKey )
        {
        case '*':                                     // Стирание при ошибке ввода
          k=0;
          break;
        case '#':                                     // Действие при нажатии #
          for (int x=0; x<k; x++) {
            if(button_pressed[x] == myarraw[x]){
              s++;             
            } 
            else {
                    s = 0;
                    incorrectPIN();
                    break;
            }
          if(s==NUM_KEYS){
              s = 0;
                correctPIN();
                break;
              }
          }        
           Serial.println();
          k=0;
          delay(100); 
          break;
        }    
  }

}
